package com.loafle.overflow.crawler.wmi;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.loafle.overflow.crawler.Crawler;
import com.loafle.overflow.crawler.config.Config;
import com.loafle.overflow.crawler.result.OFResultSet;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;


/**
 * Created by root on 17. 4. 11.
 */
public class WMICrawler extends Crawler {

    @Override
    public Object getInternal(Config config) throws Exception {

        return WMICrawlerOS.getInstance().process(config);
    }

    @Override
    public Object getInternalMeta(Config c) throws Exception {

        List<Config> metaConfigList = loadMetaConfig();


        List<OFResultSet> retlist = new ArrayList<>();
        WMICrawlerOS os = WMICrawlerOS.getInstance();
        OFResultSet ofResultSet = null;
        for(Config metaConfig : metaConfigList) {

            for(int indexI = 0; indexI < metaConfig.getItems().size(); ++indexI) {
                ofResultSet = os.processWMI(c, metaConfig.getItems().get(indexI));
                if(ofResultSet != null) {
                    retlist.add(ofResultSet);
                }
            }
        }

        return null;
    }


    private List<Config> loadMetaConfig() throws IOException {
        ClassLoader classLoader = getClass().getClassLoader();
        ObjectMapper mapper = new ObjectMapper();

        URL url = classLoader.getResource("config/meta");
        if(url == null) {
            return null;
        }

        String path = url.getFile();

        File pathFile = new File(path);

        System.out.println(path);
        String[] metaFiles = pathFile.list();
        List<Config> retList = new ArrayList<>();
        Config metaConfig = null;
        for(String fi : metaFiles) {
            if(fi.indexOf("meta_") > -1) {
                metaConfig = mapper.readValue(new File(path+"/"+fi), Config.class);
                if(metaConfig != null) {
                    retList.add(metaConfig);
                }
            }
        }

        return retList;
    }
}
